VERSION 5.00
Begin VB.Form RubberBand 
   Caption         =   "RubberBand Demo"
   ClientHeight    =   4860
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7950
   LinkTopic       =   "Form1"
   ScaleHeight     =   4860
   ScaleWidth      =   7950
   StartUpPosition =   3  'Windows Default
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Width"
      Height          =   255
      Index           =   3
      Left            =   5400
      TabIndex        =   8
      Top             =   3600
      Width           =   735
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Height"
      Height          =   255
      Index           =   2
      Left            =   5400
      TabIndex        =   7
      Top             =   4200
      Width           =   735
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Top"
      Height          =   255
      Index           =   1
      Left            =   5400
      TabIndex        =   6
      Top             =   3000
      Width           =   735
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Left"
      Height          =   255
      Index           =   0
      Left            =   5400
      TabIndex        =   5
      Top             =   2400
      Width           =   735
   End
   Begin VB.Label Label2 
      BackColor       =   &H80000009&
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Index           =   3
      Left            =   6360
      TabIndex        =   4
      Top             =   3480
      Width           =   1095
   End
   Begin VB.Label Label2 
      BackColor       =   &H80000009&
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Index           =   2
      Left            =   6360
      TabIndex        =   3
      Top             =   4080
      Width           =   1095
   End
   Begin VB.Label Label2 
      BackColor       =   &H80000009&
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Index           =   1
      Left            =   6360
      TabIndex        =   2
      Top             =   2880
      Width           =   1095
   End
   Begin VB.Label Label2 
      BackColor       =   &H80000009&
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Index           =   0
      Left            =   6360
      TabIndex        =   1
      Top             =   2280
      Width           =   1095
   End
   Begin VB.Label Label1 
      BackColor       =   &H80000013&
      BorderStyle     =   1  'Fixed Single
      Caption         =   $"frmRubberBand.frx":0000
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000C0&
      Height          =   1965
      Left            =   360
      TabIndex        =   0
      Top             =   120
      Width           =   7095
   End
End
Attribute VB_Name = "RubberBand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' Author:  Brad Perkins
'' Date:    Nov 1997
'' bradley@gvn.net
'' http://pluto.gvn.net/bradley
''
'' DemoApp Purpose:  RubberBand a rectangular region and return
'' a RECT.  Uses Several API functions to provide smooth, flicker-
'' free drawing.  This code is derived from various Microsoft
'' sample 'C' code.
''
'' Usage granted as long as this Header Remains Intact and credit
'' given where Credit is Due.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit


''''''''''''''''''''''''''''''''''''''''''''''
'' TRUE if we are rubber-banding
Private bClicked As Boolean


Private Sub Form_Load()
    ScaleMode = vbPixels
    AutoRedraw = True
End Sub


''''''''''''''''''''''''''''''''''''''''''
'' release Capture and UnHook
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Unload Me
End Sub


''''''''''''''''''''''''''''''''''''
'' Release Memory to system
Private Sub Form_Unload(Cancel As Integer)
    Set RubberBand = Nothing
End Sub


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''  Turn mousepointer into crosshair on first click
''  Set a flag to test on next mouse_down Message
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub Form_Click()
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''
    '' If this is the 2nd time we clicked
    '' the form
    If Not bClicked Then
    
        bClicked = True
        
        '''''''''''''''''''''''''''''''''''''''''''''''''''''
        '' turn the cursor into a crosshair ...
        Screen.MousePointer = vbCrosshair
        
        '''''''''''''''''''''''''''''''''''''''''''''''''''''
        '' Set the capture so we get mouse messages from all
        '' windows. If we dont do this here, we wont get
        '' the next mouse click.
        SetCapture Me.hWnd
                        
    '''''''''''''''''''''''''''''''''''''''''''''''
    '' If (bfrmClickedOnce)
    End If
                 

''''''''''''''''''''''''''''''''''''''''''''
'' End Form_Click(...)
End Sub



''''''''''''''''''''''''''''''''''''''''''''''
'' Start RubberBanding here
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, _
                x As Single, y As Single)
    
    If (Button And vbLeftButton) Then
               
        ''''''''''''''''''''''''''''''''''''''''''''''''''
        '' If this is the 2nd time we pressed the left
        '' button
        If bClicked And Screen.MousePointer = vbCrosshair Then
            Dim r As RECT
            Dim pt As POINTAPI
            
            '''''''''''''''''''''''''''''''''''''''''''''
            '' Reset flag for next drag operation
            bClicked = False
            
            ''''''''''''''''''''''''''''''''''''''''''''''
            '' Set starting point
            pt.x = x
            pt.y = y
            
            '''''''''''''''''''''''''''''''''''''''''''''''
            '' Start rubberbanding the capture area
            r = CaptureRect(Me.hWnd, pt)
                                       
            '''''''''''''''''''''''''''''''''''''''''''''''
            '' Display results; Top, Left and...
            Label2(0) = r.Left
            Label2(1) = r.Top
            
            ''''''''''''''''''''''''''''''''''''''''''''''
            ''  ... Height And Width
            Label2(2) = r.Bottom - r.Top
            Label2(3) = r.Right - r.Left
        End If
        
    '''''''''''''''''''''''''''''''''''''''''''''''
    '' If LeftButton Down
    End If
    
'''''''''''''''''''''''''''''''''''''''''''''''
'' End Form_MouseDown(...)
End Sub



Private Sub Form_MouseUp(Button As Integer, Shift As Integer, _
        x As Single, y As Single)
        
    '''''''''''''''''''''''''''''''''''''''''''''''
    '' Restore mousepointer
    If (Button And vbLeftButton) Then
        Screen.MousePointer = vbNormal
    End If
End Sub

